#ifndef fbt_interface_h
#define fbt_interface_h
extern "C"
{
  void fbt_(double f(double&), double &qT, double &Q, int &nu, double &z, int &n, double &res);
  //Input
  // f:   function to transform
  // qT:  value of qT of the transform
  // Q:   estimated maximum of the function f
  // nu:  order of the Bessel function (only 1 and 2 available)
  // z:   parameter for fragmentation functions, should be set to 1
  // n:   order of the quadrature rule
  //Output
  // res: result of the Bessel transform
  double get_ht_(double f(double&), int &nu, int &n, double &qT, double &Q);
  // f:   function to transform
  // nu:  order of the Bessel function (only 1 and 2 available)
  // n:   order of the quadrature rule
  // qT:  value of qT of the transform
  // Q:   estimated maximum of the function f
  //Output
  // ht:  optimal h spacing

}
#endif
