c.....Function BK(n,z)
c.....BK(n,z) is the n-derivative of BesselK[nu,z]
c.....with respect to nu in nu=1

c.....Itilde defined as in the paper

      function Itilde(m,xmio)
      implicit none
      include 'types.f'
      real(dp)::  zbesselk0,zbesselk1,zbesselk2,zbesselk3
      real(dp)::  argum,Itilde
      real(dp)::  Eulergamma,b0,z2,z3,logx
      real(dp)::  xmio 
      integer::   m
      real(dp)::  zeta3,zeta5,pi
      real(dp)::  zbesselk4,zbesselk5


      Eulergamma=0.577215664902_dp
      z2=1.64493406685_dp
      z3=1.20205690316_dp
      zeta3=1.20205690316_dp
      zeta5=1.03692775514337_dp
      pi=3.14159265359_dp
      b0=2._dp*exp(-Eulergamma) 

C

      argum=b0*xmio
      logx=log(xmio)
      
c      write(*,*)'logx : ',logx
      
      if (m.eq.1) then
         Itilde=-zbesselk0(argum)/xmio**2
      elseif (m.eq.2) then
         Itilde=2._dp/xmio**2*(zbesselk0(argum)*logx-zbesselk1(argum))
      elseif (m.eq.3) then
         Itilde=-3._dp/xmio**2*(zbesselk0(argum)*(logx**2-z2)
     &          -2._dp*zbesselk1(argum)*logx+zbesselk2(argum))
      elseif (m.eq.4) then
         Itilde=4._dp/xmio**2*(zbesselk0(argum)*(logx**3
     &    -3._dp*z2*logx+2._dp*z3)
     &         -3._dp*zbesselk1(argum)*(logx**2-z2)
     & +3._dp*zbesselk2(argum)*logx
     &         -zbesselk3(argum))
      elseif (m.eq.5) then
         Itilde=-((zbesselk0(argum)*
     -   (60._dp*logx**4 -60._dp*logx**2*Pi**2+Pi**4 + 480._dp*logx*Zeta3)
     -   + 60._dp*(-((-6._dp*logx**2 + Pi**2)*zbesselk2(argum)) + 
     -          zbesselk4(argum) + 
     -          2*zbesselk1(argum)*
     -           (-2._dp*logx**3 + logx*Pi**2 - 4._dp*Zeta3) - 
     -          4._dp*logx*zbesselk3(argum))))/(12.*xmio**2)
       elseif (m.eq.6) then
         Itilde=((-12._dp*(-5._dp*logx*zbesselk4(argum) 
     -    + zbesselk5(argum)) - 
     -   60._dp*zbesselk2(argum)*(-2._dp*logx**3 + logx*Pi**2 - 4._dp
     -   *Zeta3) - 
     -   zbesselk1(argum)*
     -  (60._dp*logx**4 - 60._dp*logx**2*Pi**2 + Pi**4 + 480._dp
     -   *logx*Zeta3)
     -   + zbesselk0(argum)*
     -  (12._dp*logx**5 - 20._dp*logx**3*Pi**2 + logx*Pi**4 + 
     -  240._dp*logx**2*Zeta3 - 40._dp*Pi**2*Zeta3 + 288._dp*Zeta5) + 
     -  20._dp*(-6._dp*logx**2 + Pi**2)*zbesselk3(argum)))/(2._dp*xmio**2)
       endif

      return
      end

C     n-derivative of the function BesselK[nu,z] 
C     with respect to nu for nu=1
C     NOTE: IT IS MULTIPLIED by z
      function zbesselk0(z)
      implicit none
      include 'types.f'
      real(dp)::  zbesselk0,z,zm,loz,egamma,pi
      real(dp)::  eeuler
      eeuler=2.718281828459045_dp
      egamma=0.577215664902_dp
      pi=3.14159265359_dp
      
      if(z.lt.3._dp) then
      zm=z/2_dp
      loz=log(zm)

      zbesselk0= 1._dp /z + z**11*(-1.9568173093250174e-9_dp + 
     -     6.204396874336763e-10_dp*log(zm)) + 
     -  z**9*(-7.770963034178011e-7_dp + 
     - 3.806947246871986e-7_dp*log(zm)) + 
     -  z**7*(-0.00007295580867653204_dp + 
     -     0.00004918270439533566_dp*log(zm)) + 
     -  z**5*(-0.002844868582056397_dp + 
     -     0.0025828992984131354_dp*log(zm)) + 
     -  z**3*(-0.04207095955537502_dp + 0.06248372325478707_dp*log(zm))+ 
     -  z*(0.03860479530107303_dp + 0.4999990044676526_dp*log(zm))
      else
      zbesselk0=(sqrt(pi/2._dp)*(1._dp + 1.6271357104995827_dp/z**9 - 
     -      2.0775891146104253_dp/z**8 + 1.3186131406126491_dp/z**7 - 
     -      0.6142162845331862_dp/z**6 + 0.2742600112221317_dp/z**5 - 
     -      0.14411925913723683_dp/z**4 + 105/(1024._dp*z**3) - 
     -      15._dp/(128._dp*z**2) + 3._dp/(8._dp*z)))/(eeuler**z*sqrt(z))
      endif
      zbesselk0=z*zbesselk0
      
c      write(*,*)'zbesselk0 : ',zbesselk0
      
      return
      end


      function zbesselk1(z)
      implicit none
      include 'types.f'
      real(dp)::  zbesselk1,z,zm,loz,egamma,pi
      real(dp)::  eeuler
      eeuler=2.718281828459045_dp
      egamma=0.577215664902_dp
      pi=3.14159265359_dp
      zm=z/2._dp
      loz=log(zm)
      
      if(z.lt.8._dp) then
      
      zbesselk1=    (-eGamma - log(zm))/z + 
     -  z**5*(0.0005445617329157385_dp - 
     -     0.00043328238996689255_dp*log(zm) - 
     -     9.2218242242577e-7_dp*log(zm)**2) + 
     -  z**7*(9.67340921252793e-6 - 7.156158345653147e-6_dp*Log(zm) - 
     -     4.039937532008896e-7_dp*log(zm)**2) + 
     -  z*(0.10569595353360219_dp - 0.25000005627849614_dp*Log(zm) - 
     -     6.24147362576693e-9_dp*log(zm)**2) + 
     -  z**11*(-3.254330373118915e-10_dp + 
     -     1.4387998472285715e-10_dp*log(zm) - 
     -     1.6792364502175397e-11_dp*log(zm)**2) + 
     -  z**9*(2.4255786847575995e-7_dp - 1.6665637854438636e-7_dp*log(zm) + 
     -     3.77285415065162e-8_dp*log(zm)**2) + 
     -  z**3*(0.01442189584728118_dp - 0.015622439310558685_dp*log(zm)+ 
     -     6.864577160008374e-7_dp*log(zm)**2)
      else
      zbesselk1=(sqrt(Pi/2._dp)*(0.42009479252682214_dp/z**9 - 
     -       0.5749493301786599_dp/z**8 + 0.3988478437721542/z**7 - 
     -       0.21002932881888509_dp/z**6 + 0.11118984529984352_dp/z**5 - 
     -       0.07321877720789259_dp/z**4))/(eeuler**z*sqrt(z)) + 
     - (sqrt(Pi/2._dp)*(9._dp/(128._dp*z**3) - 
     -  1._dp/(8.*z**2)+1._dp/z))/(eeuler**z*sqrt(z))
      endif
      zbesselk1=zbesselk1*z
      return
      end


      function zbesselk2(z)
      implicit none
      include 'types.f'
      real(dp)::  zbesselk2,z,loz,zm,pi
      real(dp)::  eeuler,egamma
      eeuler=2.718281828459045_dp
      egamma=0.577215664902_dp
      pi=3.14159265359_dp
      zm=z/2._dp
      loz=log(zm)
      
      if(z.lt.6._dp) then
      zbesselk2= eGamma**2/z+ Pi**2/(6._dp*z)+(2._dp*eGamma*log(zm))/z + 
     -  Log(zm)**2/z + z**9*
     -   (-1.1096880138886767e-6_dp - 1.4145925949713008e-7_dp*log(zm) + 
     -     4.382176667485917e-7_dp*log(zm)**2 - 
     -     1.1462312611839891e-7_dp*log(zm)**3) + 
     -  z**11*(-3.3041658537334376e-9_dp + 
     -     3.493797914870155e-9_dp*log(zm) - 
     -     1.1032341765418095e-9_dp*log(zm)**2 + 
     -     1.1309408971799255e-10_dp*log(zm)**3) + 
     -  z**7*(0.00002521832722532969_dp - 
     -     0.000011677813429174172_dp*log(zm) + 
     -     5.2103864151130125e-6_dp*log(zm)**2 + 
     -     0.000010590303889587856_dp*log(zm)**3) + 
     -  z**5*(-0.01609268248219179_dp+0.014649238316413526_dp*log(zm)- 
     -     0.005614240097962535_dp*log(zm)**2 + 
     -     0.0010721994233995732_dp*log(zm)**3) + 
     -  z**3*(-0.10118712484842636_dp+0.22845237135153199_dp*log(zm) - 
     -     0.033781004950253414_dp*log(zm)**2 + 
     -     0.023015657043808053_dp*log(zm)**3) + 
     -  z*(0.2054402474322794_dp + 1.202786988967297_dp*log(zm) + 
     -     0.039105327921025695_dp*log(zm)**2 + 
     -     0.16670389449151293_dp*log(zm)**3)
      else
      zbesselk2=  (sqrt(Pi/2._dp)*(-13.468022912581745_dp/z**9 + 
     -       18.076120660476747_dp/z**8 - 11.93935813472955_dp/z**7 + 
     -       5.687517812824324_dp/z**6 - 2.5404571625395915_dp/z**5 + 
     -       1.3086219840749778_dp/z**4))/(eeuler**z*sqrt(z)) + 
     -  (Sqrt(Pi/2._dp)*(-341._dp/(384._dp*z**3) + 7._dp/(8._dp*z**2) + 1._dp/z))/
     -   (eeuler**z*Sqrt(z))
      endif
      zbesselk2=zbesselk2*z
      return
      end


      FUNCTION zbesselk3(z)
      implicit none
      include 'types.f'
      real(dp)::  zbesselk3,z,loz,zm,pi
      real(dp)::  eeuler,egamma,PolyGamma21
      PolyGamma21=-2.4041138063191885_dp
      eeuler=2.718281828459045_dp
      egamma=0.577215664902_dp
      pi=3.14159265359_dp
      zm=z/2._dp
      loz=log(zm)
      if(z.lt.7._dp) then
       zbesselk3=-(eGamma**3/z) - (eGamma*Pi**2)/(2._dp*z) - 
     -  (3._dp*eGamma**2*log(zm))/z - (Pi**2*log(zm))/(2._dp*z) - 
     -  (3._dp*eGamma*log(zm)**2)/z - log(zm)**3/z + 
     -  z*(0.741460241029615_dp - 2.1278111188182285_dp*log(zm) + 
     -     0.31444247966654976_dp*log(zm)**2 - 
     -     0.25032537272853045_dp*log(zm)**3 - 
     -     0.000015721614699601564_dp*log(zm)**4) + 
     -  z**9*(-3.780756148667136e-8_dp - 2.0988468761059903e-8_dp*log(zm) + 
     -     1.025118417979933e-9_dp*log(zm)**2 + 
     -     1.1828023953209832e-8_dp*log(zm)**3 - 
     -     3.2604614001222562e-9_dp*log(zm)**4) + 
     -  z**11*(-2.0030359833905856e-10_dp + 
     -     3.2722258049753533e-12_dp*log(zm) + 
     -     9.348648533451791e-11_dp*log(zm)**2 - 
     -     3.485132595470281e-11_dp*log(zm)**3 + 
     -     3.70126563296125e-12_dp*log(zm)**4) + 
     -  z**7*(-7.328057005683732e-7_dp -1.1192712852292522e-6_dp*log(zm) - 
     -     1.6024698926144212e-7_dp*log(zm)**2 + 
     -     9.81583030479405e-7_dp*log(zm)**3 + 
     -     1.36979501025109e-7_dp*log(zm)**4) + 
     -  z**5*(-0.0010076763673720203_dp + 
     -     0.0002932356038776032_dp*log(zm) + 
     -     0.0003493611561087661_dp*log(zm)**2 - 
     -     0.00020868661587670326_dp*log(zm)**3 + 
     -     0.0000658974962924789_dp*log(zm)**4) + 
     -  z**3*(0.167838544733698_dp - 0.1453838703844178_dp*log(zm) + 
     -     0.06545971714647686_dp*log(zm)**2 - 
     -     0.011138599820957013_dp*log(zm)**3 + 
     -     0.0012800191966302714_dp*log(zm)**4) + PolyGamma21/z
      else
       zbesselk3=(sqrt(Pi/2._dp)*(106.44620944119647_dp/z**9 - 
     -       58.37806654559939_dp/z**8 + 7.450838235044999_dp/z**7 + 
     -       3.6016364796987252_dp/z**6 - 2.9784500897878723_dp/z**5 + 
     -       2.0191092994232305_dp/z**4))/(eeuler**z*sqrt(z)) + 
     -  (sqrt(Pi/2._dp)*(-15._dp/(8._dp*z**3) + 
     -  3._dp/z**2))/(eeuler**z*sqrt(z))
      endif
      zbesselk3=zbesselk3*z
      return
      end

      function zbesselk4(z)
      implicit none
      include 'types.f'
      real(dp)::  zbesselk4,z,loz,zm,pi
      real(dp)::  eeuler,egamma,PolyGamma21
      PolyGamma21=-2.4041138063191885_dp
      eeuler=2.718281828459045_dp
      egamma=0.577215664902_dp
      pi=3.14159265359_dp
      zm=z/2._dp
      loz=log(zm)
      if(z.lt.5.5_dp) then
        zbesselk4 = eGamma**4/z + (eGamma**2*Pi**2)/z +
     -   (3._dp*Pi**4)/(20._dp*z) + 
     -  (4._dp*eGamma**3*log(zm))/z + 
     -  (2._dp*eGamma*Pi**2*log(zm))/z + 
     -  (6._dp*eGamma**2*log(zm)**2)/z + (Pi**2*log(zm)**2)/z + 
     -  (4._dp*eGamma*log(zm)**3)/z + log(zm)**4/z + 
     -  z**3*(-0.6990103389989298_dp + 0.2647501413748899_dp*log(zm) - 
     -     0.03612283672025482_dp*log(zm)**2 - 
     -     0.10915978188312153_dp*log(zm)**3 + 
     -     0.004118477390445751_dp*log(zm)**4 - 
     -     0.010502109174191825_dp*log(zm)**5) + 
     -  z**7*(-0.000026507343057088608_dp - 
     -     0.000035100394544916634_dp*log(zm) - 
     -     0.00002019186258218856_dp*log(zm)**2 + 
     -     4.956917504034691e-6_dp*log(zm)**3 + 
     -     0.000016590650701070783_dp*log(zm)**4 - 
     -     3.4782174602420115e-6_dp*log(zm)**5) + 
     -  z**9*(-3.258870660059446e-7_dp - 2.1997277361697343e-7_dp*Log(zm) - 
     -     1.1019392922982706e-7_dp*log(zm)**2 + 
     -     3.399888940284931e-8_dp*log(zm)**3 + 
     -     1.0503587820426808e-7_dp*log(zm)**4 - 
     -     4.528041398016384e-8_dp*log(zm)**5) + 
     -  z**11*(-2.002482600657661e-9_dp - 
     -     6.844408501384899e-10_dp*log(zm) + 
     -     5.52905668993192e-10_dp*log(zm)**2 + 
     -     9.635316235709776e-10_dp*log(zm)**3 - 
     -     4.940900883115303e-10_dp*log(zm)**4 + 
     -     6.24327519306621e-11_dp*log(zm)**5) + 
     -  z**5*(0.005226661016840685_dp + 0.003498229777955057_dp*log(zm) + 
     -     0.0005555004369970303_dp*log(zm)**2 - 
     -     0.0006742350389641484_dp*log(zm)**3 + 
     -     0.000682781735442639_dp*log(zm)**4 + 
     -     0.000287688677882766_dp*log(zm)**5) + 
     -  z*(-3.1213484797068_dp + 10.186888475001425_dp*log(zm) - 
     -     0.30236597294901296_dp*log(zm)**2 + 
     -     2.138455900031443_dp*log(zm)**3 + 
     -     0.014429535355278255_dp*log(zm)**4 + 
     -     0.09905461351738745_dp*log(zm)**5) - 
     -  (4._dp*eGamma*PolyGamma21)/z - (4_dp*log(zm)*PolyGamma21)/z
      else
       zbesselk4=(sqrt(Pi/2._dp)*(206.377433723454_dp/z**9 - 
     -       212.54389434510247_dp/z**8 + 
     -       112.33062205600746_dp/z**7 - 45.24740388415563_dp/z**6 + 
     -       17.70156755450591_dp/z**5 - 7.599350575591011_dp/z**4))/
     -   (eeuler**z*sqrt(z))+(sqrt(Pi/2._dp)*(25._dp/(8.*z**3) + 3._dp/z**2))/
     -   (eeuler**z*Sqrt(z))
      endif
      zbesselk4=zbesselk4*z
      return
      end

      function zbesselk5(z)
      implicit none
      include 'types.f'
      real(dp):: zbesselk5,z,loz,zm,pi
      real(dp):: eeuler,egamma,PolyGamma21,PolyGamma41
      PolyGamma21=-2.4041138063191885_dp
      PolyGamma41=-24.88626612344088_dp
      eeuler=2.718281828459045_dp
      egamma=0.577215664902_dp
      pi=3.14159265359_dp
      zm=z/2._dp
      loz=log(zm)
      if(z.lt.4.8_dp) then
        zbesselk5 = -(eGamma**5/z) - (5._dp*eGamma**3*Pi**2)/(3._dp*z) - 
     -  (3._dp*eGamma*Pi**4)/(4._dp*z) - (5._dp*eGamma**4*Log(zm))/z - 
     -  (5._dp*eGamma**2*Pi**2*log(zm))/z - 
     -  (3._dp*Pi**4*log(zm))/(4._dp*z) - 
     -  (10._dp*eGamma**3*log(zm)**2)/z - 
     -  (5._dp*eGamma*Pi**2*log(zm)**2)/z - 
     -  (10._dp*eGamma**2*log(zm)**3)/z - 
     -  (5._dp*Pi**2*log(zm)**3)/(3._dp*z) - (5._dp*eGamma*log(zm)**4)/z - 
     -  log(zm)**5/z + z**5*
     -   (-0.027974491674421235_dp - 0.027906409260920736_dp*log(zm) - 
     -     0.014563807094391418_dp*log(zm)**2 + 
     -     0.0008990007546083161_dp*log(zm)**3 + 
     -     0.003512164715470154_dp*log(zm)**4 - 
     -     0.004612485282021637_dp*log(zm)**5 - 
     -     0.00044319160664944125_dp*log(zm)**6) + 
     -  z**11*(6.470845657407899e-9_dp + 2.70876845591316e-9_dp*log(zm) + 
     -     1.6131090508152676e-11_dp*log(zm)**2 - 
     -     2.25998178969873e-9_dp*log(zm)**3 - 
     -     2.2048536549280954e-9_dp*log(zm)**4 + 
     -     1.362889761121793e-9_dp*log(zm)**5 - 
     -     1.8292724241667642d-10*log(zm)**6) + 
     -  z**9*(1.4926014484768381e-6_dp + 8.293731812123973e-7_dp*log(zm) + 
     -     4.893100227286569e-7_dp*log(zm)**2 + 
     -     1.7588855866626588e-7_dp*log(zm)**3 - 
     -     1.6760675457423107e-7_dp*log(zm)**4 - 
     -     2.506167032306423e-7_dp*log(zm)**5 + 
     -     1.4414027622517258e-7_dp*log(zm)**6) + 
     -  z**7*(0.00003947365092334642_dp + 
     -     0.00015049773724843535_dp*log(zm) + 
     -     0.00014274648882114447_dp*log(zm)**2 + 
     -     0.00005894439393202595_dp*log(zm)**3 - 
     -     0.00003257098108512634_dp*log(zm)**4 - 
     -     0.00005492966631282213_dp*log(zm)**5 + 
     -     0.00001718500739376941_dp*log(zm)**6) + 
     -  z*(39.106210439699844_dp - 17.35903628541634_dp*log(zm) + 
     -     20.16879146341157_dp*log(zm)**2 - 
     -     3.9315488355889996_dp*log(zm)**3 + 
     -     0.972933331379283_dp*log(zm)**4 - 
     -     0.2154931593252161_dp*log(zm)**5 + 
     -     0.001146355563669418_dp*log(zm)**6) + 
     -  z**3*(-2.283721316504047_dp + 1.990494555096448_dp*log(zm) + 
     -     0.6119407758779737_dp*log(zm)**2 - 
     -     0.1402449073644081_dp*log(zm)**3 + 
     -     0.5802357941619685_dp*log(zm)**4 - 
     -     0.004732133006444116_dp*log(zm)**5 + 
     -     0.04022608322817004_dp*log(zm)**6) + 
     -  (10._dp*eGamma**2*PolyGamma21)/z + 
     -  (5._dp*Pi**2*PolyGamma21)/(3._dp*z) + 
     -  (20._dp*eGamma*log(zm)*PolyGamma21)/z + 
     -  (10._dp*log(zm)**2*PolyGamma21)/z + PolyGamma41/z
      else
       zbesselk5=(15._dp*sqrt(Pi/2._dp))/(eeuler**z*z**3.5_dp) + 
     -  (sqrt(Pi/2._dp)*(289.76394840007436_dp/z**9 - 
     -       310.9583973839412_dp/z**8 + 176.90636258280088_dp/z**7 - 
     -       80.84496366754149_dp/z**6 + 38.403475414780125_dp/z**5 - 
     -       21.872229107044735_dp/z**4))/(eeuler**z*sqrt(z))
      endif
      zbesselk5=zbesselk5*z
      return
      end

c$$$      function zbesselk0(z)
c$$$      implicit none
c$$$      double precision zbesselk0,z,zm,loz,egamma,pi,r(0:11),zbk0
c$$$      data r(0)/ 6.03844076705d2/
c$$$      data r(1)/ -1.21597891877d2/
c$$$      data r(2)/ 2.72488273113d1/
c$$$      data r(3)/ -6.88391426811d0/
c$$$      data r(4)/ 1.99353173375d0/
c$$$      data r(5)/ -0.676592588425d0/
c$$$      data r(6)/ 0.277576446533d0/
c$$$      data r(7)/ -0.144195556641d0/
c$$$      data r(8)/ 0.102539062500d0/
c$$$      data r(9)/ -0.1171875d0/
c$$$      data r(10)/ 0.375d0/
c$$$      data r(11)/ 1d0/
c$$$
c$$$      egamma=0.577215664902d0
c$$$      pi=3.14159265359d0
c$$$      if(z.lt.1.5d0) then
c$$$      zm=z/2d0
c$$$      loz=dlog(zm)
c$$$
c$$$      zbesselk0=1d0+z*zm*(loz-0.5d0*(1-2*egamma))
c$$$     &         +zm**4*(loz-0.5d0*(2.5d0-2*egamma))
c$$$     &         +zm**6/6d0*(loz-0.5d0*(10d0/3-2*egamma))
c$$$     &         +zm**8/72d0*(loz-0.5d0*(47d0/12-2*egamma))
c$$$     &         +zm**10/1440d0*(loz-0.5d0*(131d0/30-2*egamma))
c$$$      elseif(z.ge.1.5d0.and.z.lt.4d0) then
c$$$      zbesselk0=zbk0(z)
c$$$      else
c$$$      zbesselk0=dsqrt(Pi/2d0)*(z)**(-10.5d0)*dexp(-z)*
c$$$     &    (r(0)+r(1)*z+r(2)*z**2+r(3)*z**3+r(4)*z**4+r(5)*z**5+
c$$$     &     r(6)*z**6+r(7)*z**7+r(8)*z**8+r(9)*z**9+r(10)*z**10+
c$$$     &     r(11)*z**11)
c$$$      endif
c$$$      return
c$$$      end
c$$$      
c$$$      
c$$$
c$$$      function zbesselk1(z)
c$$$      implicit none
c$$$      double precision zbesselk1,z,zm,loz,egamma,pi,r(0:11),zbk1
c$$$      data r(0) /-5.51335896122d2/
c$$$      data r(1) /1.10017140269d2/
c$$$      data r(2) /-2.43805296996d1/
c$$$      data r(3) /6.07404200127d0/
c$$$      data r(4) /-1.72772750258d0/
c$$$      data r(5) /0.572501420975d0/
c$$$      data r(6) /-0.227108001709d0/
c$$$      data r(7) /0.112152099609d0/
c$$$      data r(8) /-7.32421875d-2/
c$$$      data r(9) /7.03125d-2/
c$$$      data r(10) /-0.125d0/
c$$$      data r(11) /1d0/
c$$$
c$$$      egamma=0.577215664902d0
c$$$      pi=3.14159265359d0
c$$$      if(z.lt.1.5d0) then
c$$$      zm=z/2d0
c$$$      loz=dlog(zm)
c$$$      zbesselk1=-(loz+egamma)-zm**2*(loz-1+egamma)
c$$$     &         -0.25d0*zm**4*(loz-1.5d0+egamma)
c$$$     &         -zm**6/36d0*(loz-11d0/6+egamma)
c$$$     &         -zm**8/576d0*(loz-25d0/12+egamma)
c$$$      elseif(z.ge.1.5d0.and.z.lt.4d0) then
c$$$      zbesselk1=zbk1(z)
c$$$      else
c$$$      zbesselk1=dsqrt(Pi/2d0)*(z)**(-11.5d0)*dexp(-z)*
c$$$     &    (r(0)+r(1)*z+r(2)*z**2+r(3)*z**3+r(4)*z**4+r(5)*z**5+
c$$$     &     r(6)*z**6+r(7)*z**7+r(8)*z**8+r(9)*z**9+r(10)*z**10+
c$$$     &     r(11)*z**11)
c$$$      endif
c$$$      return
c$$$      end
c$$$
c$$$
c$$$      function zbesselk2(z)
c$$$      implicit none
c$$$      double precision zbesselk2,z,a(0:13),loz,zm,pi,r(0:11),zbk2
c$$$      data a(0) / 1.15443132980306572d0/
c$$$      data a(1) / 1.97811199065594511d0/
c$$$      data a(2) / 0.154431329803065721d0/
c$$$      data a(3) / 4.801792651508824500d0/
c$$$      data a(4) / 0.806235643470665767d0/
c$$$      data a(5) /-0.672784335098467139d0/
c$$$      data a(6) / 3.285072828402112960d0/
c$$$      data a(7) /-1.945338757678943440d0/
c$$$      data a(8) /-0.181575166960855634d0/
c$$$      data a(9) / 0.694195147571435559d0/
c$$$      data a(10)/-0.607655744858515573d0/
c$$$      data a(11)/-0.019182189839330562d0/
c$$$      data a(12)/ 0.068894530444636532d0/
c$$$      data a(13)/-0.070514317816328185d0/
c$$$
c$$$      data r(0) /3.19461756880d4/
c$$$      data r(1) /-5.82903207466d3/
c$$$      data r(2) /1.17069096329d3/
c$$$      data r(3) /-2.61456867712d2/
c$$$      data r(4) /6.57620334072d1/
c$$$      data r(5) /-18.9305966582d0/
c$$$      data r(6) /6.37010269165d0/
c$$$      data r(7) /-2.57905883789d0/
c$$$      data r(8) /1.30957031250d0/
c$$$      data r(9) /-0.888020833333d0/
c$$$      data r(10) /0.875d0/
c$$$      data r(11) /1d0/
c$$$
c$$$      pi=3.14159265359d0
c$$$      if(z.lt.1.5d0) then
c$$$      zm=z/2
c$$$      loz=dlog(zm)
c$$$      
c$$$      zbesselk2=loz**2+a(0)*loz+a(1)
c$$$     &       +zm**2*(2*loz**3/3d0+a(2)*loz**2+a(3)*loz+a(4))
c$$$     &       +zm**4*(loz**3/3d0+a(5)*loz**2+a(6)*loz+a(7))
c$$$     &       +zm**6*(loz**3/18d0+a(8)*loz**2+a(9)*loz+a(10))
c$$$     &       +zm**8*(loz**3/216d0+a(11)*loz**2+a(12)*loz+a(13))
c$$$      elseif(z.ge.1.5d0.and.z.lt.4d0) then
c$$$      zbesselk2=zbk2(z)
c$$$      else
c$$$      zbesselk2=dsqrt(Pi/2d0)*(z)**(-11.5d0)*dexp(-z)*
c$$$     &    (r(0)+r(1)*z+r(2)*z**2+r(3)*z**3+r(4)*z**4+r(5)*z**5+
c$$$     &     r(6)*z**6+r(7)*z**7+r(8)*z**8+r(9)*z**9+r(10)*z**10+
c$$$     &     r(11)*z**11)
c$$$      endif
c$$$      return
c$$$      end
c$$$
c$$$
c$$$      function zbesselk3(z)
c$$$      implicit none
c$$$      double precision zbesselk3,z,b(0:14),loz,zm,pi,r(0:9),zbk3
c$$$
c$$$      data b(0) / 1.731646994704598580d0/
c$$$      data b(1) / 5.934335971967835330d0/
c$$$      data b(2) / 5.444874456485317730d0/
c$$$      data b(3) /-1.268353005295401420d0/ 
c$$$      data b(4) / 8.471041982558638170d0/
c$$$      data b(5) /-3.026167526073320430d0/
c$$$      data b(6) /-0.692088251323850355d0/ 
c$$$      data b(7) / 2.809848746963509900d0/
c$$$      data b(8) /-2.161466255000085060d0/
c$$$      data b(9) /-0.104676472369316706d0/
c$$$      data b(10)/ 0.381989731242156681d0/
c$$$      data b(11)/-0.367492827636283900d0/
c$$$      data b(12)/-0.007844362856415627d0/
c$$$      data b(13)/ 0.027796539630842606d0/
c$$$      data b(14)/-0.029917436634978395d0/
c$$$
c$$$      data r(0)/-3.19152148877d3/
c$$$      data r(1)/7.05641513542d2/
c$$$      data r(2)/-1.75295543138d2/
c$$$      data r(3)/4.96775524480d1/
c$$$      data r(4)/-1.63798988342d1/
c$$$      data r(5)/6.45276489258d0/
c$$$      data r(6)/-3.15332031250d0/
c$$$      data r(7)/2.0234375d0/
c$$$      data r(8)/-1.875d0/
c$$$      data r(9)/3d0/
c$$$
c$$$      pi=3.14159265359d0
c$$$      if(z.lt.1.5d0) then
c$$$       zm=z/2
c$$$       loz=dlog(zm)
c$$$      
c$$$       zbesselk3=loz**3+b(0)*loz**2+b(1)*loz+b(2)
c$$$     &       +zm**2*(loz**3+b(3)*loz**2+b(4)*loz+b(5))
c$$$     &       +zm**4*(loz**3/4d0+b(6)*loz**2+b(7)*loz+b(8))
c$$$     &       +zm**6*(loz**3/36d0+b(9)*loz**2+b(10)*loz+b(11))
c$$$     &       +zm**8*(loz**3/576d0+b(12)*loz**2+b(13)*loz+b(14))
c$$$       zbesselk3=-zbesselk3
c$$$      elseif(z.ge.1.5d0.and.z.lt.4d0) then
c$$$      zbesselk3=zbk3(z)
c$$$      else
c$$$       zbesselk3=dsqrt(Pi/2d0)*(z)**(-10.5d0)*dexp(-z)*
c$$$     &    (r(0)+r(1)*z+r(2)*z**2+r(3)*z**3+r(4)*z**4+r(5)*z**5+
c$$$     &     r(6)*z**6+r(7)*z**7+r(8)*z**8+r(9)*z**9)
c$$$      endif
c$$$      return
c$$$      end
c$$$
c$$$C     n-derivative of the function BesselK[nu,z] 
c$$$C     with respect to nu for nu=1, multiplied by z
c$$$
c$$$C     Interpolated form from z=1 to z=5
c$$$
c$$$      function zbk0(x)
c$$$      implicit none
c$$$      integer i,j
c$$$      real*8 xa(1:21),ya(1:21),xx(1:5),yy(1:5),zbk0,x,y,dy   
c$$$	   DATA XA/1d0,1.2d0,1.4d0,1.6d0,1.8d0,2d0,2.2d0,2.4d0,
c$$$     &             2.6d0,2.8d0,3d0,3.2d0,3.4d0,3.6d0,3.8d0,4d0,
c$$$     &             4.2d0,4.4d0,4.6d0,4.8d0,5d0/
c$$$           DATA YA/0.601907230197d0,0.521510869273d0,0.449170263122d0,
c$$$     &             0.385014258172d0,0.328721579643d0,0.279731763633d0,
c$$$     &             0.237372982262d0,0.200939613012d0,0.169738517152d0,
c$$$     &             1.431155197d-1,1.20469293385d-1,1.01257264676d-1,
c$$$     &             8.49965460188d-2,7.12618632710d-2,5.96817704982d-2,
c$$$     &             4.99339955491d-2,4.17404598909d-2,3.48623147904d-2,
c$$$     &             2.90952007636d-2,2.42648469315d-2,2.02230672273d-2/
c$$$  
c$$$         call locate(xa,21,x,j)
c$$$         if (j.lt.2) j=2
c$$$         if (j.gt.20) j=20
c$$$         do i=1,4
c$$$         xx(i)=xa(j+i-2)
c$$$         yy(i)=ya(j+i-2)
c$$$         enddo
c$$$         call xpolint(xx,yy,4,x,y,dy)
c$$$	    zbk0=y
c$$$         if(x.lt.1d0) zbk0=0d0
c$$$
c$$$       end
c$$$
c$$$      function zbk1(x)
c$$$      implicit none
c$$$      integer i,j
c$$$      real*8 xa(1:21),ya(1:21),xx(1:5),yy(1:5),zbk1,x,y,dy   
c$$$	   DATA XA/1d0,1.2d0,1.4d0,1.6d0,1.8d0,2d0,2.2d0,2.4d0,
c$$$     &             2.6d0,2.8d0,3d0,3.2d0,3.4d0,3.6d0,3.8d0,4d0,
c$$$     &             4.2d0,4.4d0,4.6d0,4.8d0,5d0/
c$$$           DATA YA/0.421024438241d0,0.318508220287d0,0.243655061182d0,
c$$$     &             0.187954751969d0,0.14593140049d0,0.11389387275d0,
c$$$     &             8.92690056716d-2,7.02173415434d-2,5.53983032863d-2,
c$$$     &             4.3819981975d-2,3.47395043863d-2,2.75949976751d-2,
c$$$     &             2.19580188068d-2,1.74996410181d-2,1.39658845342d-2,
c$$$     &             1.11596760859d-2,8.92745154154d-3,7.14911062331d-3,
c$$$     &             5.73042291729d-3,4.59724631672d-3,3.69109833404d-3/
c$$$  
c$$$         call locate(xa,21,x,j)
c$$$         if (j.lt.2) j=2
c$$$         if (j.gt.20) j=20
c$$$         do i=1,4
c$$$         xx(i)=xa(j+i-2)
c$$$         yy(i)=ya(j+i-2)
c$$$         enddo
c$$$         call xpolint(xx,yy,4,x,y,dy)
c$$$	    zbk1=y
c$$$         if(x.lt.1d0) zbk1=0d0
c$$$
c$$$       end
c$$$
c$$$      function zbk2(x)
c$$$      implicit none
c$$$      integer i,j
c$$$      real*8 xa(1:21),ya(1:21),xx(1:5),yy(1:5),zbk2,x,y,dy   
c$$$	   DATA XA/1d0,1.2d0,1.4d0,1.6d0,1.8d0,2d0,2.2d0,2.4d0,
c$$$     &             2.6d0,2.8d0,3d0,3.2d0,3.4d0,3.6d0,3.8d0,4d0,
c$$$     &             4.2d0,4.4d0,4.6d0,4.8d0,5d0/
c$$$
c$$$           DATA YA/0.680674889238d0,0.491594990820d0,0.362195189493d0,
c$$$     &             0.270816279222d0,0.204792327117d0,0.156253340447d0,
c$$$     &             0.120082673664d0,9.28359137653d-2,7.21300592003d-2,
c$$$     &             5.62799660668d-2,4.40726122853d-2,3.46219598130d-2,
c$$$     &             2.72728851066d-2,2.15360151576d-2,1.70426018226d-2,
c$$$     &             1.35127158151d-2,1.07324867217d-2,8.53760219545d-3,
c$$$     &             6.80120891232d-3,5.42495329856d-3,4.33228989306d-3/ 
c$$$
c$$$         call locate(xa,21,x,j)
c$$$         if (j.lt.2) j=2
c$$$         if (j.gt.20) j=20
c$$$         do i=1,4
c$$$         xx(i)=xa(j+i-2)
c$$$         yy(i)=ya(j+i-2)
c$$$         enddo
c$$$         call xpolint(xx,yy,4,x,y,dy)
c$$$	    zbk2=y
c$$$         if(x.lt.1d0) zbk2=0d0
c$$$
c$$$       end
c$$$
c$$$          function zbk3(x)
c$$$      implicit none
c$$$      integer i,j
c$$$      real*8 xa(1:21),ya(1:21),xx(1:5),yy(1:5),zbk3,x,y,dy   
c$$$	   DATA XA/1d0,1.2d0,1.4d0,1.6d0,1.8d0,2d0,2.2d0,2.4d0,
c$$$     &             2.6d0,2.8d0,3d0,3.2d0,3.4d0,3.6d0,3.8d0,4d0,
c$$$     &             4.2d0,4.4d0,4.6d0,4.8d0,5d0/
c$$$
c$$$           DATA YA/0.923433129276d0,0.604688213722d0,0.408298815558d0,
c$$$     &             0.282121092418d0,0.198476215508d0,0.141664802216d0,
c$$$     &             1.02324263482d-1,7.46480617096d-2,5.49203947626d-2,
c$$$     &             4.07017495249d-2,3.03561460004d-2,2.27666860711d-2,
c$$$     &             1.71591652247d-2,1.29898581976d-2,9.87254609222d-3,
c$$$     &             7.53015239679d-3,5.76215402177d-3,4.42230076800d-3,
c$$$     &             3.40318600534d-3,2.62543960976d-3,2.03008127036d-3/
c$$$
c$$$         call locate(xa,21,x,j)
c$$$         if (j.lt.2) j=2
c$$$         if (j.gt.20) j=20
c$$$         do i=1,4
c$$$         xx(i)=xa(j+i-2)
c$$$         yy(i)=ya(j+i-2)
c$$$         enddo
c$$$         call xpolint(xx,yy,4,x,y,dy)
c$$$	    zbk3=y
c$$$         if(x.lt.1d0) zbk3=0d0
c$$$
c$$$       end
c$$$
c$$$
c$$$
c$$$
c$$$       SUBROUTINE LOCATE(XX,N,X,J)
c$$$       INTEGER J,N,JL,JM,JU
c$$$       DOUBLE PRECISION X,XX(N)
c$$$       JL=0
c$$$       JU=N+1
c$$$ 10    IF(JU-JL.GT.1)THEN
c$$$              JM=(JU+JL)/2
c$$$              IF((XX(N).GE.XX(1)).EQV.(X.GE.XX(JM))) then
c$$$                  JL=JM
c$$$              ELSE
c$$$                 JU=JM
c$$$              ENDIF
c$$$       GOTO 10
c$$$       ENDIF
c$$$       IF(X.EQ.XX(1))THEN
c$$$           J=1
c$$$       ELSE IF(X.EQ.XX(N)) THEN
c$$$           J=N-1 
c$$$       ELSE 
c$$$              J=JL
c$$$       ENDIF
c$$$       RETURN
c$$$       END
c$$$
c$$$
c$$$       SUBROUTINE XPOLINT (XA,YA,N,X,Y,DY)
c$$$       IMPLICIT DOUBLE PRECISION (A-H, O-Z)
c$$$       PARAMETER (NMAX=10)
c$$$       DIMENSION XA(N),YA(N),C(NMAX),D(NMAX)
c$$$       NS=1
c$$$       DIF=ABS(X-XA(1))
c$$$       DO 11 I=1,N
c$$$       DIFT=ABS(X-XA(I))
c$$$       IF (DIFT.LT.DIF) THEN
c$$$         NS=I
c$$$         DIF=DIFT
c$$$       ENDIF
c$$$       C(I)=YA(I)
c$$$       D(I)=YA(I)
c$$$ 11    CONTINUE
c$$$       Y=YA(NS)
c$$$       NS=NS-1
c$$$       DO 13 M=1,N-1
c$$$       DO 12 I=1,N-M
c$$$         HO=XA(I)-X
c$$$         HP=XA(I+M)-X
c$$$         W=C(I+1)-D(I)
c$$$         DEN=HO-HP
c$$$         IF(DEN.EQ.0.)PAUSE
c$$$         DEN=W/DEN
c$$$         D(I)=HP*DEN
c$$$         C(I)=HO*DEN
c$$$ 12    CONTINUE
c$$$       IF (2*NS.LT.N-M)THEN
c$$$         DY=C(NS+1)
c$$$       ELSE
c$$$         DY=D(NS)
c$$$         NS=NS-1
c$$$       ENDIF
c$$$       Y=Y+DY
c$$$ 13    CONTINUE
c$$$       RETURN
c$$$       END
