#include "muf.h"
#include "resint.h"
#include "pmom.h"
#include "anomalous.h"
#include "mesq.h"
#include "settings.h"
#include "scales.h"
#include "pdfevol.h"
#include "parton.h"
#include "ccoeff.h"
//#include "anomalous.h"
#include "pmom.h"
#include "resconst.h"
#include "expc.h"
#include "hcoeff.h"

#include <iostream>

double muf::LR  ;
double muf::LR2 ;
double muf::LR3 ;
double muf::LF  ;
double muf::LF2 ;
double muf::LF3 ;
double muf::LF4 ;
double muf::LQ  ;
double muf::LQ2 ;
double muf::LQ3 ;
double muf::LQ4 ;
double muf::LQ5 ;
double muf::LQ6 ;
double muf::LQ7 ;
double muf::LQF ;
double muf::LQF2;
double muf::LQF3;
double muf::LQF4;
double muf::A1  ;
double muf::A2  ;
double muf::A3  ;
double muf::A4  ;
double muf::B1  ;
double muf::B2  ;
double muf::B3  ;
double muf::B4  ;

complex <double> *muf::EC1qq   ;
complex <double> *muf::EC2qq   ;
complex <double> *muf::EC3qq   ;
complex <double> *muf::EC1qg   ;
complex <double> *muf::EC2qg   ;
complex <double> *muf::EC3qg   ;
complex <double> *muf::EC2qqp  ;
complex <double> *muf::EC2qqb  ;
complex <double> *muf::EC2qqbp ;
complex <double> *muf::EC3qqp  ;
complex <double> *muf::EC3qqb  ;
complex <double> *muf::EC3qqbp ;

//LL
complex <double> *muf::qqb;
//NLL
complex <double> *muf::qg;
complex <double> *muf::qg_1;
complex <double> *muf::qg_2;
//NNLL
complex <double> *muf::qq;
complex <double> *muf::qq_1;
complex <double> *muf::qq_2;
complex <double> *muf::qqp;
complex <double> *muf::qqp_1;
complex <double> *muf::qqp_2;
complex <double> *muf::qqbp;
complex <double> *muf::qqbp_1;
complex <double> *muf::qqbp_2;
complex <double> *muf::gg;
//NNNLL
complex <double> *muf::qbg;
complex <double> *muf::qbg_1;
complex <double> *muf::qbg_2;
complex <double> *muf::qpg;
complex <double> *muf::qpg_1;
complex <double> *muf::qpg_2;
complex <double> *muf::qbpg;
complex <double> *muf::qbpg_1;
complex <double> *muf::qbpg_2;
//NNNNLL
complex <double> *muf::qbq;
complex <double> *muf::qpqbp;
complex <double> *muf::qbpqp;
complex <double> *muf::qbqp;
complex <double> *muf::qbqp_1;
complex <double> *muf::qbqp_2;
complex <double> *muf::qbqbp;
complex <double> *muf::qbqbp_1;
complex <double> *muf::qbqbp_2;
complex <double> *muf::qpqp;
complex <double> *muf::qpqp_1;
complex <double> *muf::qpqp_2;


//Split b-dependent C exponentiation
//mellin 1d
complex <double> *muf::qqb_eqqb;
complex <double> *muf::qg_eqqb;
complex <double> *muf::qq_eqqb;
complex <double> *muf::qqp_eqqb;
complex <double> *muf::qqbp_eqqb;
complex <double> *muf::gg_eqqb;
complex <double> *muf::qbg_eqqb;
complex <double> *muf::qpg_eqqb;
complex <double> *muf::qbpg_eqqb;
complex <double> *muf::qbq_eqqb;
complex <double> *muf::qpqbp_eqqb;
complex <double> *muf::qbpqp_eqqb;
complex <double> *muf::qbqp_eqqb;
complex <double> *muf::qbqbp_eqqb;
complex <double> *muf::qpqp_eqqb;
complex <double> *muf::qqb_eqg;
complex <double> *muf::qg_eqg;
complex <double> *muf::qq_eqg;
complex <double> *muf::qqp_eqg;
complex <double> *muf::qqbp_eqg;
complex <double> *muf::gg_eqg;
complex <double> *muf::qbg_eqg;
complex <double> *muf::qpg_eqg;
complex <double> *muf::qbpg_eqg;
complex <double> *muf::qbq_eqg;
complex <double> *muf::qbqp_eqg;
complex <double> *muf::qbqbp_eqg;
complex <double> *muf::qpqp_eqg;
complex <double> *muf::qpqbp_eqg;
complex <double> *muf::qbpqp_eqg;
complex <double> *muf::qg_eqq;
complex <double> *muf::qq_eqq;
complex <double> *muf::qbg_eqq;
complex <double> *muf::gg_eqq;
complex <double> *muf::qbq_eqq;
complex <double> *muf::qbqp_eqq;
complex <double> *muf::qbqbp_eqq;
complex <double> *muf::qg_eqqp;
complex <double> *muf::qqp_eqqp;
complex <double> *muf::qbpg_eqqp;
complex <double> *muf::gg_eqqp;
complex <double> *muf::qbqp_eqqp;
complex <double> *muf::qpqp_eqqp;
complex <double> *muf::qbpqp_eqqp;
complex <double> *muf::qg_eqqbp;
complex <double> *muf::qqbp_eqqbp;
complex <double> *muf::qpg_eqqbp;
complex <double> *muf::gg_eqqbp;
complex <double> *muf::qbqbp_eqqbp;
complex <double> *muf::qpqp_eqqbp;
complex <double> *muf::qpqbp_eqqbp;
complex <double> *muf::qg_egg;
complex <double> *muf::gg_egg;
complex <double> *muf::qbg_egg;
complex <double> *muf::qpg_egg;
complex <double> *muf::qbpg_egg;
complex <double> *muf::qqb_egg;
complex <double> *muf::qq_egg;
complex <double> *muf::qqp_egg;
complex <double> *muf::qqbp_egg;
complex <double> *muf::qbq_egg;
complex <double> *muf::qbqp_egg;
complex <double> *muf::qbqbp_egg;
complex <double> *muf::qpqp_egg;
complex <double> *muf::qpqbp_egg;
complex <double> *muf::qbpqp_egg;
complex <double> *muf::qq_eqbg;
complex <double> *muf::gg_eqbg;
complex <double> *muf::qbg_eqbg;
complex <double> *muf::qbq_eqbg;
complex <double> *muf::qbqp_eqbg;
complex <double> *muf::qbqbp_eqbg;
complex <double> *muf::qqbp_eqpg;
complex <double> *muf::gg_eqpg;
complex <double> *muf::qpg_eqpg;
complex <double> *muf::qbqbp_eqpg;
complex <double> *muf::qpqp_eqpg;
complex <double> *muf::qpqbp_eqpg;
complex <double> *muf::qqp_eqbpg;
complex <double> *muf::gg_eqbpg;
complex <double> *muf::qbpg_eqbpg;
complex <double> *muf::qbqp_eqbpg;
complex <double> *muf::qpqp_eqbpg;
complex <double> *muf::qbpqp_eqbpg;

//mellin 2d
complex <double> *muf::qg_1_eqqb;
complex <double> *muf::qg_2_eqqb;
complex <double> *muf::qq_1_eqqb;
complex <double> *muf::qq_2_eqqb;
complex <double> *muf::qqp_1_eqqb;
complex <double> *muf::qqp_2_eqqb;
complex <double> *muf::qqbp_1_eqqb;
complex <double> *muf::qqbp_2_eqqb;
complex <double> *muf::qbg_1_eqqb;
complex <double> *muf::qbg_2_eqqb;
complex <double> *muf::qpg_1_eqqb;
complex <double> *muf::qpg_2_eqqb;
complex <double> *muf::qbpg_1_eqqb;
complex <double> *muf::qbpg_2_eqqb;
complex <double> *muf::qqb_eqg_1;
complex <double> *muf::qg_1_eqg_1;
complex <double> *muf::qg_2_eqg_1;
complex <double> *muf::qq_1_eqg_1;
complex <double> *muf::qqp_1_eqg_1;
complex <double> *muf::qqbp_1_eqg_1;
complex <double> *muf::gg_eqg_1;
complex <double> *muf::qbg_1_eqg_1;
complex <double> *muf::qbg_2_eqg_1;
complex <double> *muf::qpg_1_eqg_1;
complex <double> *muf::qpg_2_eqg_1;
complex <double> *muf::qbpg_1_eqg_1;
complex <double> *muf::qbpg_2_eqg_1;
complex <double> *muf::qqb_eqg_2;
complex <double> *muf::qg_1_eqg_2;
complex <double> *muf::qg_2_eqg_2;
complex <double> *muf::qq_2_eqg_2;
complex <double> *muf::qqp_2_eqg_2;
complex <double> *muf::qqbp_2_eqg_2;
complex <double> *muf::gg_eqg_2;
complex <double> *muf::qbg_1_eqg_2;
complex <double> *muf::qbg_2_eqg_2;
complex <double> *muf::qpg_1_eqg_2;
complex <double> *muf::qpg_2_eqg_2;
complex <double> *muf::qbpg_1_eqg_2;
complex <double> *muf::qbpg_2_eqg_2;
complex <double> *muf::qg_1_eqq_1;
complex <double> *muf::qq_1_eqq_1;
complex <double> *muf::qbg_2_eqq_1;
complex <double> *muf::qg_2_eqq_2;
complex <double> *muf::qq_2_eqq_2;
complex <double> *muf::qbg_1_eqq_2;
complex <double> *muf::qg_1_eqqp_1;
complex <double> *muf::qqp_1_eqqp_1;
complex <double> *muf::qbpg_2_eqqp_1;
complex <double> *muf::qg_2_eqqp_2;
complex <double> *muf::qqp_2_eqqp_2;
complex <double> *muf::qbpg_1_eqqp_2;
complex <double> *muf::qg_1_eqqbp_1;
complex <double> *muf::qqbp_1_eqqbp_1;
complex <double> *muf::qpg_2_eqqbp_1;
complex <double> *muf::qg_2_eqqbp_2;
complex <double> *muf::qqbp_2_eqqbp_2;
complex <double> *muf::qpg_1_eqqbp_2;
complex <double> *muf::qg_1_egg;
complex <double> *muf::qg_2_egg;
complex <double> *muf::qbg_1_egg;
complex <double> *muf::qbg_2_egg;
complex <double> *muf::qpg_1_egg;
complex <double> *muf::qpg_2_egg;
complex <double> *muf::qbpg_1_egg;
complex <double> *muf::qbpg_2_egg;

//using namespace ccoeff;
using namespace pmom;
using namespace resconst;
//using namespace resint;
using namespace ccoeff;

  //allocate memory
void muf::allocate()
{
  //if (opts.order == 0)
  //return;

  if (opts.mellin1d)
    {
      qqb  = new complex <double> [mellinint::mdim*2];
      qg   = new complex <double> [mellinint::mdim*2];
      qq   = new complex <double> [mellinint::mdim*2];
      qqp  = new complex <double> [mellinint::mdim*2];
      qqbp = new complex <double> [mellinint::mdim*2];
      gg   = new complex <double> [mellinint::mdim*2];
      qbg  = new complex <double> [mellinint::mdim*2];
      qpg  = new complex <double> [mellinint::mdim*2];
      qbpg = new complex <double> [mellinint::mdim*2];
      qbq   = new complex <double> [mellinint::mdim*2];
      qpqbp = new complex <double> [mellinint::mdim*2];
      qbpqp = new complex <double> [mellinint::mdim*2];
      qbqp  = new complex <double> [mellinint::mdim*2];
      qbqbp = new complex <double> [mellinint::mdim*2];
      qpqp  = new complex <double> [mellinint::mdim*2];

      qqb_eqqb   = new complex <double> [mellinint::mdim*2];
      qg_eqqb    = new complex <double> [mellinint::mdim*2];
      qq_eqqb    = new complex <double> [mellinint::mdim*2];
      qqp_eqqb   = new complex <double> [mellinint::mdim*2];
      qqbp_eqqb  = new complex <double> [mellinint::mdim*2];
      gg_eqqb    = new complex <double> [mellinint::mdim*2];
      qbg_eqqb   = new complex <double> [mellinint::mdim*2];
      qpg_eqqb   = new complex <double> [mellinint::mdim*2];
      qbpg_eqqb  = new complex <double> [mellinint::mdim*2];
      qbq_eqqb    = new complex <double> [mellinint::mdim*2];
      qpqbp_eqqb  = new complex <double> [mellinint::mdim*2];
      qbpqp_eqqb  = new complex <double> [mellinint::mdim*2];
      qbqp_eqqb   = new complex <double> [mellinint::mdim*2];
      qbqbp_eqqb  = new complex <double> [mellinint::mdim*2];
      qpqp_eqqb   = new complex <double> [mellinint::mdim*2];
      qqb_eqg    = new complex <double> [mellinint::mdim*2];
      qg_eqg     = new complex <double> [mellinint::mdim*2];
      qq_eqg     = new complex <double> [mellinint::mdim*2];
      qqp_eqg    = new complex <double> [mellinint::mdim*2];
      qqbp_eqg   = new complex <double> [mellinint::mdim*2];
      gg_eqg     = new complex <double> [mellinint::mdim*2];
      qbg_eqg    = new complex <double> [mellinint::mdim*2];
      qpg_eqg    = new complex <double> [mellinint::mdim*2];
      qbpg_eqg   = new complex <double> [mellinint::mdim*2];
      qbq_eqg   = new complex <double> [mellinint::mdim*2];
      qbqp_eqg  = new complex <double> [mellinint::mdim*2];
      qbqbp_eqg = new complex <double> [mellinint::mdim*2];
      qpqp_eqg  = new complex <double> [mellinint::mdim*2];
      qpqbp_eqg = new complex <double> [mellinint::mdim*2];
      qbpqp_eqg = new complex <double> [mellinint::mdim*2];
      qg_eqq     = new complex <double> [mellinint::mdim*2];
      qq_eqq     = new complex <double> [mellinint::mdim*2];
      qbg_eqq    = new complex <double> [mellinint::mdim*2];
      gg_eqq     = new complex <double> [mellinint::mdim*2];
      qbq_eqq    = new complex <double> [mellinint::mdim*2];
      qbqp_eqq   = new complex <double> [mellinint::mdim*2];
      qbqbp_eqq  = new complex <double> [mellinint::mdim*2];
      qg_eqqp    = new complex <double> [mellinint::mdim*2];
      qqp_eqqp  = new complex <double> [mellinint::mdim*2];
      qbpg_eqqp   = new complex <double> [mellinint::mdim*2];
      gg_eqqp     = new complex <double> [mellinint::mdim*2];
      qbqp_eqqp   = new complex <double> [mellinint::mdim*2];
      qpqp_eqqp   = new complex <double> [mellinint::mdim*2];
      qbpqp_eqqp  = new complex <double> [mellinint::mdim*2];
      qg_eqqbp   = new complex <double> [mellinint::mdim*2];
      qqbp_eqqbp  = new complex <double> [mellinint::mdim*2];
      qpg_eqqbp = new complex <double> [mellinint::mdim*2];
      gg_eqqbp     = new complex <double> [mellinint::mdim*2];
      qbqbp_eqqbp  = new complex <double> [mellinint::mdim*2];
      qpqp_eqqbp   = new complex <double> [mellinint::mdim*2];
      qpqbp_eqqbp  = new complex <double> [mellinint::mdim*2];
      qg_egg     = new complex <double> [mellinint::mdim*2];
      gg_egg     = new complex <double> [mellinint::mdim*2];
      qbg_egg    = new complex <double> [mellinint::mdim*2];
      qpg_egg    = new complex <double> [mellinint::mdim*2];
      qbpg_egg   = new complex <double> [mellinint::mdim*2];
      qqb_egg       = new complex <double> [mellinint::mdim*2];
      qq_egg	    = new complex <double> [mellinint::mdim*2];
      qqp_egg       = new complex <double> [mellinint::mdim*2];
      qqbp_egg      = new complex <double> [mellinint::mdim*2];
      qbq_egg       = new complex <double> [mellinint::mdim*2];
      qbqp_egg      = new complex <double> [mellinint::mdim*2];
      qbqbp_egg     = new complex <double> [mellinint::mdim*2];
      qpqp_egg      = new complex <double> [mellinint::mdim*2];
      qpqbp_egg     = new complex <double> [mellinint::mdim*2];
      qbpqp_egg     = new complex <double> [mellinint::mdim*2];
      qq_eqbg       = new complex <double> [mellinint::mdim*2];
      gg_eqbg       = new complex <double> [mellinint::mdim*2];
      qbg_eqbg      = new complex <double> [mellinint::mdim*2];
      qbq_eqbg      = new complex <double> [mellinint::mdim*2];
      qbqp_eqbg     = new complex <double> [mellinint::mdim*2];
      qbqbp_eqbg    = new complex <double> [mellinint::mdim*2];
      qqbp_eqpg     = new complex <double> [mellinint::mdim*2];
      gg_eqpg       = new complex <double> [mellinint::mdim*2];
      qpg_eqpg      = new complex <double> [mellinint::mdim*2];
      qbqbp_eqpg    = new complex <double> [mellinint::mdim*2];
      qpqp_eqpg     = new complex <double> [mellinint::mdim*2];
      qpqbp_eqpg    = new complex <double> [mellinint::mdim*2];
      qqp_eqbpg     = new complex <double> [mellinint::mdim*2];
      gg_eqbpg      = new complex <double> [mellinint::mdim*2];
      qbpg_eqbpg    = new complex <double> [mellinint::mdim*2];
      qbqp_eqbpg    = new complex <double> [mellinint::mdim*2];
      qpqp_eqbpg    = new complex <double> [mellinint::mdim*2];
      qbpqp_eqbpg   = new complex <double> [mellinint::mdim*2];

      EC1qq    = new complex <double> [mellinint::mdim*2];
      EC2qq    = new complex <double> [mellinint::mdim*2];
      EC3qq    = new complex <double> [mellinint::mdim*2];
      EC1qg    = new complex <double> [mellinint::mdim*2];
      EC2qg    = new complex <double> [mellinint::mdim*2];
      EC3qg    = new complex <double> [mellinint::mdim*2];
      EC2qqp   = new complex <double> [mellinint::mdim*2];
      EC2qqb   = new complex <double> [mellinint::mdim*2];
      EC2qqbp  = new complex <double> [mellinint::mdim*2];
      EC3qqp   = new complex <double> [mellinint::mdim*2];
      EC3qqb   = new complex <double> [mellinint::mdim*2];
      EC3qqbp  = new complex <double> [mellinint::mdim*2];
    }
  else
    {
      qqb    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_1   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_2   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qq_1   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qq_2   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqp_1  = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqp_2  = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqbp_1 = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqbp_2 = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      gg     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbg_1  = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbg_2  = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpg_1  = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpg_2  = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbpg_1 = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbpg_2 = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbq     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpqbp   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbpqp   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbqp_1  = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbqp_2  = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbqbp_1 = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbqbp_2 = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpqp_1  = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpqp_2  = new complex <double> [mellinint::mdim*mellinint::mdim*2];  

      qqb_eqqb       = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      gg_eqqb	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      gg_egg	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_1_eqqb      = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_2_eqqb	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qq_1_eqqb	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qq_2_eqqb	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqp_1_eqqb     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqp_2_eqqb     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqbp_1_eqqb    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqbp_2_eqqb    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbg_1_eqqb     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbg_2_eqqb     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpg_1_eqqb     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpg_2_eqqb     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbpg_1_eqqb    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbpg_2_eqqb    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqb_eqg_1	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_1_eqg_1     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_2_eqg_1     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qq_1_eqg_1     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqp_1_eqg_1    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqbp_1_eqg_1   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      gg_eqg_1	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbg_1_eqg_1    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbg_2_eqg_1    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpg_1_eqg_1    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpg_2_eqg_1    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbpg_1_eqg_1   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbpg_2_eqg_1   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqb_eqg_2	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_1_eqg_2     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_2_eqg_2     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qq_2_eqg_2     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqp_2_eqg_2    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqbp_2_eqg_2   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      gg_eqg_2	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbg_1_eqg_2    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbg_2_eqg_2    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpg_1_eqg_2    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpg_2_eqg_2    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbpg_1_eqg_2   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbpg_2_eqg_2   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_1_eqq_1     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qq_1_eqq_1     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbg_2_eqq_1    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_2_eqq_2     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qq_2_eqq_2     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbg_1_eqq_2    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_1_eqqp_1    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqp_1_eqqp_1   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbpg_2_eqqp_1  = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_2_eqqp_2    = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqp_2_eqqp_2   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbpg_1_eqqp_2  = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_1_eqqbp_1   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqbp_1_eqqbp_1 = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpg_2_eqqbp_1  = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_2_eqqbp_2   = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qqbp_2_eqqbp_2 = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpg_1_eqqbp_2  = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_1_egg	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qg_2_egg	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbg_1_egg	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbg_2_egg	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpg_1_egg	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qpg_2_egg	     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbpg_1_egg     = new complex <double> [mellinint::mdim*mellinint::mdim*2];
      qbpg_2_egg     = new complex <double> [mellinint::mdim*mellinint::mdim*2]; 
    }
}

void muf::free()
{
  //if (opts.order == 0)
  //return;

  if (opts.mellin1d)
    {
      delete[] qqb;
      delete[] qg;
      delete[] qq;
      delete[] qqp;  
      delete[] qqbp;
      delete[] gg;
      delete[] qbg;
      delete[] qpg;
      delete[] qbpg;
      delete[] qbq;
      delete[] qpqbp;
      delete[] qbpqp;
      delete[] qbqp;
      delete[] qbqbp;
      delete[] qpqp;

      delete[] qqb_eqqb;
      delete[] qg_eqqb;
      delete[] qq_eqqb;
      delete[] qqp_eqqb;
      delete[] qqbp_eqqb;
      delete[] gg_eqqb;
      delete[] qbg_eqqb;
      delete[] qpg_eqqb;
      delete[] qbpg_eqqb;
      delete[] qbq_eqqb;
      delete[] qpqbp_eqqb;
      delete[] qbpqp_eqqb;
      delete[] qbqp_eqqb;
      delete[] qbqbp_eqqb;
      delete[] qpqp_eqqb;
      delete[] qqb_eqg;
      delete[] qg_eqg;
      delete[] qq_eqg;
      delete[] qqp_eqg;
      delete[] qqbp_eqg;
      delete[] gg_eqg;
      delete[] qbg_eqg;
      delete[] qpg_eqg;
      delete[] qbpg_eqg;
      delete[] qbq_eqg;
      delete[] qbqp_eqg;
      delete[] qbqbp_eqg;
      delete[] qpqp_eqg;
      delete[] qpqbp_eqg;
      delete[] qbpqp_eqg;
      delete[] qg_eqq;
      delete[] qq_eqq;
      delete[] qbg_eqq;
      delete[] gg_eqq;
      delete[] qbq_eqq;
      delete[] qbqp_eqq;
      delete[] qbqbp_eqq;
      delete[] qg_eqqp;
      delete[] qqp_eqqp;
      delete[] qbpg_eqqp;
      delete[] gg_eqqp;
      delete[] qbqp_eqqp;
      delete[] qpqp_eqqp;
      delete[] qbpqp_eqqp;
      delete[] qg_eqqbp;
      delete[] qqbp_eqqbp;
      delete[] qpg_eqqbp;
      delete[] gg_eqqbp;
      delete[] qbqbp_eqqbp;
      delete[] qpqp_eqqbp;
      delete[] qpqbp_eqqbp;
      delete[] qg_egg;
      delete[] gg_egg;
      delete[] qbg_egg;
      delete[] qpg_egg;
      delete[] qbpg_egg;
      delete[] qqb_egg;
      delete[] qq_egg;
      delete[] qqp_egg;
      delete[] qqbp_egg;
      delete[] qbq_egg;
      delete[] qbqp_egg;
      delete[] qbqbp_egg;
      delete[] qpqp_egg;
      delete[] qpqbp_egg;
      delete[] qbpqp_egg;
      delete[] qq_eqbg;
      delete[] gg_eqbg;
      delete[] qbg_eqbg;
      delete[] qbq_eqbg;
      delete[] qbqp_eqbg;
      delete[] qbqbp_eqbg;
      delete[] qqbp_eqpg;
      delete[] gg_eqpg;
      delete[] qpg_eqpg;
      delete[] qbqbp_eqpg;
      delete[] qpqp_eqpg;
      delete[] qpqbp_eqpg;
      delete[] qqp_eqbpg;
      delete[] gg_eqbpg;
      delete[] qbpg_eqbpg;
      delete[] qbqp_eqbpg;
      delete[] qpqp_eqbpg;
      delete[] qbpqp_eqbpg;

      delete[] EC1qq  ;
      delete[] EC2qq  ;
      delete[] EC3qq  ;
      delete[] EC1qg  ;
      delete[] EC2qg  ;
      delete[] EC3qg  ;
      delete[] EC2qqp ;
      delete[] EC2qqb ;
      delete[] EC2qqbp;
      delete[] EC3qqp ;
      delete[] EC3qqb ;
      delete[] EC3qqbp;
    }
  else
    {
      delete[] qqb;
      delete[] qg_1;
      delete[] qg_2;
      delete[] qq_1;
      delete[] qq_2;
      delete[] qqp_1;
      delete[] qqp_2;
      delete[] qqbp_1;
      delete[] qqbp_2;
      delete[] gg;
      delete[] qbg_1;
      delete[] qbg_2;
      delete[] qpg_1;
      delete[] qpg_2;
      delete[] qbpg_1;
      delete[] qbpg_2;
      delete[] qbq;
      delete[] qpqbp;
      delete[] qbpqp;
      delete[] qbqp_1;
      delete[] qbqp_2;
      delete[] qbqbp_1;
      delete[] qbqbp_2;
      delete[] qpqp_1;
      delete[] qpqp_2;

      delete[] qqb_eqqb;
      delete[] gg_eqqb;
      delete[] gg_egg;
      delete[] qg_1_eqqb;
      delete[] qg_2_eqqb;
      delete[] qq_1_eqqb;
      delete[] qq_2_eqqb;
      delete[] qqp_1_eqqb;
      delete[] qqp_2_eqqb;
      delete[] qqbp_1_eqqb;
      delete[] qqbp_2_eqqb;
      delete[] qbg_1_eqqb;
      delete[] qbg_2_eqqb;
      delete[] qpg_1_eqqb;
      delete[] qpg_2_eqqb;
      delete[] qbpg_1_eqqb;
      delete[] qbpg_2_eqqb;
      delete[] qqb_eqg_1;
      delete[] qg_1_eqg_1;
      delete[] qg_2_eqg_1;
      delete[] qq_1_eqg_1;
      delete[] qqp_1_eqg_1;
      delete[] qqbp_1_eqg_1;
      delete[] gg_eqg_1;
      delete[] qbg_1_eqg_1;
      delete[] qbg_2_eqg_1;
      delete[] qpg_1_eqg_1;
      delete[] qpg_2_eqg_1;
      delete[] qbpg_1_eqg_1;
      delete[] qbpg_2_eqg_1;
      delete[] qqb_eqg_2;
      delete[] qg_1_eqg_2;
      delete[] qg_2_eqg_2;
      delete[] qq_2_eqg_2;
      delete[] qqp_2_eqg_2;
      delete[] qqbp_2_eqg_2;
      delete[] gg_eqg_2;
      delete[] qbg_1_eqg_2;
      delete[] qbg_2_eqg_2;
      delete[] qpg_1_eqg_2;
      delete[] qpg_2_eqg_2;
      delete[] qbpg_1_eqg_2;
      delete[] qbpg_2_eqg_2;
      delete[] qg_1_eqq_1;
      delete[] qq_1_eqq_1;
      delete[] qbg_2_eqq_1;
      delete[] qg_2_eqq_2;
      delete[] qq_2_eqq_2;
      delete[] qbg_1_eqq_2;
      delete[] qg_1_eqqp_1;
      delete[] qqp_1_eqqp_1;
      delete[] qbpg_2_eqqp_1;
      delete[] qg_2_eqqp_2;
      delete[] qqp_2_eqqp_2;
      delete[] qbpg_1_eqqp_2;
      delete[] qg_1_eqqbp_1;
      delete[] qqbp_1_eqqbp_1;
      delete[] qpg_2_eqqbp_1;
      delete[] qg_2_eqqbp_2;
      delete[] qqbp_2_eqqbp_2;
      delete[] qpg_1_eqqbp_2;
      delete[] qg_1_egg;
      delete[] qg_2_egg;
      delete[] qbg_1_egg;
      delete[] qbg_2_egg;
      delete[] qpg_1_egg;
      delete[] qpg_2_egg;
      delete[] qbpg_1_egg;
      delete[] qbpg_2_egg;
    }
}

void muf::reset()
{
  //if (opts.order == 0)
  //return;

  if (opts.mellin1d)
    {
      fill(qqb , qqb  + mellinint::mdim*2, 0.);
      fill(qg  , qg   + mellinint::mdim*2, 0.);
      fill(qq  , qq   + mellinint::mdim*2, 0.);
      fill(qqp , qqp  + mellinint::mdim*2, 0.);
      fill(qqbp, qqbp + mellinint::mdim*2, 0.);
      fill(gg  , gg   + mellinint::mdim*2, 0.);
      fill(qbg , qbg  + mellinint::mdim*2, 0.);
      fill(qpg , qpg  + mellinint::mdim*2, 0.);
      fill(qbpg, qbpg + mellinint::mdim*2, 0.);
      fill(qbq   , qbq   + mellinint::mdim*2, 0.);
      fill(qpqbp , qpqbp + mellinint::mdim*2, 0.);
      fill(qbpqp , qbpqp + mellinint::mdim*2, 0.);
      fill(qbqp  , qbqp  + mellinint::mdim*2, 0.);
      fill(qbqbp , qbqbp + mellinint::mdim*2, 0.);
      fill(qpqp  , qpqp  + mellinint::mdim*2, 0.);

      fill(qqb_eqqb   , qqb_eqqb   + mellinint::mdim*2, 0.);
      fill(qg_eqqb    ,	qg_eqqb    + mellinint::mdim*2, 0.);
      fill(qq_eqqb    ,	qq_eqqb    + mellinint::mdim*2, 0.);
      fill(qqp_eqqb   ,	qqp_eqqb   + mellinint::mdim*2, 0.);
      fill(qqbp_eqqb  ,	qqbp_eqqb  + mellinint::mdim*2, 0.);
      fill(gg_eqqb    ,	gg_eqqb    + mellinint::mdim*2, 0.);
      fill(qbg_eqqb   ,	qbg_eqqb   + mellinint::mdim*2, 0.);
      fill(qpg_eqqb   ,	qpg_eqqb   + mellinint::mdim*2, 0.);
      fill(qbpg_eqqb  ,	qbpg_eqqb  + mellinint::mdim*2, 0.);
      fill(qbq_eqqb   , qbq_eqqb   + mellinint::mdim*2, 0.);
      fill(qpqbp_eqqb ,	qpqbp_eqqb + mellinint::mdim*2, 0.);
      fill(qbpqp_eqqb ,	qbpqp_eqqb + mellinint::mdim*2, 0.);
      fill(qbqp_eqqb  ,	qbqp_eqqb  + mellinint::mdim*2, 0.);
      fill(qbqbp_eqqb ,	qbqbp_eqqb + mellinint::mdim*2, 0.);
      fill(qpqp_eqqb  ,	qpqp_eqqb  + mellinint::mdim*2, 0.);
      fill(qqb_eqg    ,	qqb_eqg    + mellinint::mdim*2, 0.);
      fill(qg_eqg     ,	qg_eqg     + mellinint::mdim*2, 0.);
      fill(qq_eqg     ,	qq_eqg     + mellinint::mdim*2, 0.);
      fill(qqp_eqg    ,	qqp_eqg    + mellinint::mdim*2, 0.);
      fill(qqbp_eqg   ,	qqbp_eqg   + mellinint::mdim*2, 0.);
      fill(gg_eqg     ,	gg_eqg     + mellinint::mdim*2, 0.);
      fill(qbg_eqg    ,	qbg_eqg    + mellinint::mdim*2, 0.);
      fill(qpg_eqg    ,	qpg_eqg    + mellinint::mdim*2, 0.);
      fill(qbpg_eqg   ,	qbpg_eqg   + mellinint::mdim*2, 0.);
      fill(qbq_eqg    , qbq_eqg    + mellinint::mdim*2, 0.);
      fill(qbqp_eqg   ,	qbqp_eqg   + mellinint::mdim*2, 0.);
      fill(qbqbp_eqg  ,	qbqbp_eqg  + mellinint::mdim*2, 0.);
      fill(qpqp_eqg   ,	qpqp_eqg   + mellinint::mdim*2, 0.);
      fill(qpqbp_eqg  ,	qpqbp_eqg  + mellinint::mdim*2, 0.);
      fill(qbpqp_eqg  ,	qbpqp_eqg  + mellinint::mdim*2, 0.);
      fill(qg_eqq     ,	qg_eqq     + mellinint::mdim*2, 0.);
      fill(qq_eqq     ,	qq_eqq     + mellinint::mdim*2, 0.);
      fill(qbg_eqq    ,	qbg_eqq    + mellinint::mdim*2, 0.);
      fill(gg_eqq    , gg_eqq     + mellinint::mdim*2, 0.);
      fill(qbq_eqq   , qbq_eqq    + mellinint::mdim*2, 0.);
      fill(qbqp_eqq  , qbqp_eqq   + mellinint::mdim*2, 0.);
      fill(qbqbp_eqq , qbqbp_eqq  + mellinint::mdim*2, 0.);
      fill(qg_eqqp    ,	qg_eqqp    + mellinint::mdim*2, 0.);
      fill(qqp_eqqp   ,	qqp_eqqp  + mellinint::mdim*2, 0.);
      fill(qbpg_eqqp  ,	qbpg_eqqp   + mellinint::mdim*2, 0.);
      fill(gg_eqqp    ,gg_eqqp     + mellinint::mdim*2, 0.);
      fill(qbqp_eqqp  ,qbqp_eqqp   + mellinint::mdim*2, 0.);
      fill(qpqp_eqqp  ,qpqp_eqqp   + mellinint::mdim*2, 0.);
      fill(qbpqp_eqqp ,qbpqp_eqqp  + mellinint::mdim*2, 0.);
      fill(qg_eqqbp   ,	qg_eqqbp   + mellinint::mdim*2, 0.);
      fill(qqbp_eqqbp ,	qqbp_eqqbp  + mellinint::mdim*2, 0.);
      fill(qpg_eqqbp  ,	qpg_eqqbp + mellinint::mdim*2, 0.);
      fill(gg_eqqbp    , gg_eqqbp     + mellinint::mdim*2, 0.);
      fill(qbqbp_eqqbp , qbqbp_eqqbp  + mellinint::mdim*2, 0.);
      fill(qpqp_eqqbp  , qpqp_eqqbp   + mellinint::mdim*2, 0.);
      fill(qpqbp_eqqbp , qpqbp_eqqbp  + mellinint::mdim*2, 0.);
      fill(qg_egg     ,	qg_egg     + mellinint::mdim*2, 0.);
      fill(gg_egg     ,	gg_egg     + mellinint::mdim*2, 0.);
      fill(qbg_egg    ,	qbg_egg    + mellinint::mdim*2, 0.);
      fill(qpg_egg    ,	qpg_egg    + mellinint::mdim*2, 0.);
      fill(qbpg_egg   ,	qbpg_egg   + mellinint::mdim*2, 0.);
      fill(qqb_egg     , qqb_egg     + mellinint::mdim*2, 0.);
      fill(qq_egg      , qq_egg      + mellinint::mdim*2, 0.);
      fill(qqp_egg     , qqp_egg     + mellinint::mdim*2, 0.);
      fill(qqbp_egg    , qqbp_egg    + mellinint::mdim*2, 0.);
      fill(qbq_egg     , qbq_egg     + mellinint::mdim*2, 0.);
      fill(qbqp_egg    , qbqp_egg    + mellinint::mdim*2, 0.);
      fill(qbqbp_egg   , qbqbp_egg   + mellinint::mdim*2, 0.);
      fill(qpqp_egg    , qpqp_egg    + mellinint::mdim*2, 0.);
      fill(qpqbp_egg   , qpqbp_egg   + mellinint::mdim*2, 0.);
      fill(qbpqp_egg   , qbpqp_egg   + mellinint::mdim*2, 0.);
      fill(qq_eqbg     , qq_eqbg     + mellinint::mdim*2, 0.);
      fill(gg_eqbg     , gg_eqbg     + mellinint::mdim*2, 0.);
      fill(qbg_eqbg    , qbg_eqbg    + mellinint::mdim*2, 0.);
      fill(qbq_eqbg    , qbq_eqbg    + mellinint::mdim*2, 0.);
      fill(qbqp_eqbg   , qbqp_eqbg   + mellinint::mdim*2, 0.);
      fill(qbqbp_eqbg  , qbqbp_eqbg  + mellinint::mdim*2, 0.);
      fill(qqbp_eqpg   , qqbp_eqpg   + mellinint::mdim*2, 0.);
      fill(gg_eqpg     , gg_eqpg     + mellinint::mdim*2, 0.);
      fill(qpg_eqpg    , qpg_eqpg    + mellinint::mdim*2, 0.);
      fill(qbqbp_eqpg  , qbqbp_eqpg  + mellinint::mdim*2, 0.);
      fill(qpqp_eqpg   , qpqp_eqpg   + mellinint::mdim*2, 0.);
      fill(qpqbp_eqpg  , qpqbp_eqpg  + mellinint::mdim*2, 0.);
      fill(qqp_eqbpg   , qqp_eqbpg   + mellinint::mdim*2, 0.);
      fill(gg_eqbpg    , gg_eqbpg    + mellinint::mdim*2, 0.);
      fill(qbpg_eqbpg  , qbpg_eqbpg  + mellinint::mdim*2, 0.);
      fill(qbqp_eqbpg  , qbqp_eqbpg  + mellinint::mdim*2, 0.);
      fill(qpqp_eqbpg  , qpqp_eqbpg  + mellinint::mdim*2, 0.);
      fill(qbpqp_eqbpg , qbpqp_eqbpg + mellinint::mdim*2, 0.);
    }
  else
    {
      fill(qqb   ,qqb    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qg_1  ,qg_1   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qg_2  ,qg_2   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qq_1  ,qq_1   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qq_2  ,qq_2   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqp_1 ,qqp_1  + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqp_2 ,qqp_2  + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqbp_1,qqbp_1 + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqbp_2,qqbp_2 + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(gg    ,gg     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbg_1 ,qbg_1  + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbg_2 ,qbg_2  + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qpg_1 ,qpg_1  + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qpg_2 ,qpg_2  + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbpg_1,qbpg_1 + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbpg_2,qbpg_2 + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbq     , qbq     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qpqbp   , qpqbp   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbpqp   , qbpqp   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbqp_1  , qbqp_1  + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbqp_2  , qbqp_2  + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbqbp_1 , qbqbp_1 + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbqbp_2 , qbqbp_2 + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qpqp_1  , qpqp_1  + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qpqp_2  , qpqp_2  + mellinint::mdim*mellinint::mdim*2, 0.);  

      fill(qqb_eqqb       ,qqb_eqqb       + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(gg_eqqb	  ,gg_eqqb	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(gg_egg	  ,gg_egg	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(qg_1_eqqb      ,qg_1_eqqb      + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qg_2_eqqb	  ,qg_2_eqqb	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(qq_1_eqqb	  ,qq_1_eqqb	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(qq_2_eqqb	  ,qq_2_eqqb	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(qqp_1_eqqb     ,qqp_1_eqqb     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqp_2_eqqb     ,qqp_2_eqqb     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqbp_1_eqqb    ,qqbp_1_eqqb    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqbp_2_eqqb    ,qqbp_2_eqqb    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbg_1_eqqb     ,qbg_1_eqqb     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbg_2_eqqb     ,qbg_2_eqqb     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qpg_1_eqqb     ,qpg_1_eqqb     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qpg_2_eqqb     ,qpg_2_eqqb     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbpg_1_eqqb    ,qbpg_1_eqqb    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbpg_2_eqqb    ,qbpg_2_eqqb    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqb_eqg_1	  ,qqb_eqg_1	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(qg_1_eqg_1     ,qg_1_eqg_1     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qg_2_eqg_1     ,qg_2_eqg_1     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qq_1_eqg_1     ,qq_1_eqg_1     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqp_1_eqg_1    ,qqp_1_eqg_1    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqbp_1_eqg_1   ,qqbp_1_eqg_1   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(gg_eqg_1	  ,gg_eqg_1	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(qbg_1_eqg_1    ,qbg_1_eqg_1    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbg_2_eqg_1    ,qbg_2_eqg_1    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qpg_1_eqg_1    ,qpg_1_eqg_1    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qpg_2_eqg_1    ,qpg_2_eqg_1    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbpg_1_eqg_1   ,qbpg_1_eqg_1   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbpg_2_eqg_1   ,qbpg_2_eqg_1   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqb_eqg_2	  ,qqb_eqg_2	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(qg_1_eqg_2     ,qg_1_eqg_2     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qg_2_eqg_2     ,qg_2_eqg_2     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qq_2_eqg_2     ,qq_2_eqg_2     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqp_2_eqg_2    ,qqp_2_eqg_2    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqbp_2_eqg_2   ,qqbp_2_eqg_2   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(gg_eqg_2	  ,gg_eqg_2	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(qbg_1_eqg_2    ,qbg_1_eqg_2    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbg_2_eqg_2    ,qbg_2_eqg_2    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qpg_1_eqg_2    ,qpg_1_eqg_2    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qpg_2_eqg_2    ,qpg_2_eqg_2    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbpg_1_eqg_2   ,qbpg_1_eqg_2   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbpg_2_eqg_2   ,qbpg_2_eqg_2   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qg_1_eqq_1     ,qg_1_eqq_1     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qq_1_eqq_1     ,qq_1_eqq_1     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbg_2_eqq_1    ,qbg_2_eqq_1    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qg_2_eqq_2     ,qg_2_eqq_2     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qq_2_eqq_2     ,qq_2_eqq_2     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbg_1_eqq_2    ,qbg_1_eqq_2    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qg_1_eqqp_1    ,qg_1_eqqp_1    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqp_1_eqqp_1   ,qqp_1_eqqp_1   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbpg_2_eqqp_1  ,qbpg_2_eqqp_1  + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qg_2_eqqp_2    ,qg_2_eqqp_2    + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqp_2_eqqp_2   ,qqp_2_eqqp_2   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbpg_1_eqqp_2  ,qbpg_1_eqqp_2  + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qg_1_eqqbp_1   ,qg_1_eqqbp_1   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqbp_1_eqqbp_1 ,qqbp_1_eqqbp_1 + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qpg_2_eqqbp_1  ,qpg_2_eqqbp_1  + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qg_2_eqqbp_2   ,qg_2_eqqbp_2   + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qqbp_2_eqqbp_2 ,qqbp_2_eqqbp_2 + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qpg_1_eqqbp_2  ,qpg_1_eqqbp_2  + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qg_1_egg	  ,qg_1_egg	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(qg_2_egg	  ,qg_2_egg	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(qbg_1_egg	  ,qbg_1_egg	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(qbg_2_egg	  ,qbg_2_egg	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(qpg_1_egg	  ,qpg_1_egg	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(qpg_2_egg	  ,qpg_2_egg	  + mellinint::mdim*mellinint::mdim*2, 0.);  
      fill(qbpg_1_egg     ,qbpg_1_egg     + mellinint::mdim*mellinint::mdim*2, 0.);
      fill(qbpg_2_egg     ,qbpg_2_egg     + mellinint::mdim*mellinint::mdim*2, 0.);
    }
}

void muf::ccalc()
{
  //LO
  if (opts.order_hcoef == 0)
    return;

  if (opts.mellin1d) //rapidity integrated
    ccalc1d();
  else
    ccalc2d();
}

void muf::ccalcb(complex <double> b)
{
  //LO
  if (opts.order_hcoef == 0)
    return;

  if (opts.mellin1d) //rapidity integrated
    for (int sign = mesq::positive; sign <= mesq::negative; sign++)
      for (int i = 0; i < mellinint::mdim; i++)
	{
	  int idx = pmom::index(i,sign);
	
	  qqb[idx]  = qqb_eqqb[idx]*expc::qqb[idx];
	  qg[idx]   = qg_eqqb[idx] *expc::qqb[idx];

	  if (max(opts.order_hcoef,opts.order_evol) == 1)
	    continue;
	  
	  qqb[idx]  += qqb_eqg[idx] *expc::qg[idx];
	  qg[idx]   += qg_eqg[idx]  *expc::qg[idx];
	  qq[idx]   = qq_eqqb[idx]  *expc::qqb[idx] + qq_eqg[idx]*expc::qg[idx];
	  qqp[idx]  = qqp_eqqb[idx] *expc::qqb[idx] + qqp_eqg[idx]*expc::qg[idx];
	  qqbp[idx] = qqbp_eqqb[idx]*expc::qqb[idx] + qqbp_eqg[idx]*expc::qg[idx];
	  gg[idx]   = gg_eqqb[idx]  *expc::qqb[idx] + gg_eqg[idx]*expc::qg[idx];

	  if (max(opts.order_hcoef,opts.order_evol) == 2)
	    continue;

	  qg[idx]   += qg_eqq[idx]  *expc::qq[idx] + qg_eqqp[idx]*expc::qqp[idx] + qg_eqqbp[idx]*expc::qqbp[idx] + qg_egg[idx]*expc::gg[idx];
	  qq[idx]   += qq_eqq[idx]  *expc::qq[idx];
	  qqp[idx]  += qqp_eqqp[idx]*expc::qqp[idx];
	  qqbp[idx] += qqbp_eqqbp[idx]*expc::qqbp[idx];
	  gg[idx]   += gg_egg[idx]  *expc::gg[idx];
	  qbg[idx]  = qbg_eqqb[idx] *expc::qqb[idx] + qbg_eqg[idx]*expc::qg[idx] + qbg_eqq[idx]*expc::qq[idx] + qbg_egg[idx]*expc::gg[idx];
	  qpg[idx]  = qpg_eqqb[idx] *expc::qqb[idx] + qpg_eqg[idx]*expc::qg[idx] + qpg_eqqbp[idx]*expc::qqbp[idx] + qpg_egg[idx]*expc::gg[idx];
	  qbpg[idx] = qbpg_eqqb[idx]*expc::qqb[idx] + qbpg_eqg[idx]*expc::qg[idx] + qbpg_eqqp[idx]*expc::qqp[idx] + qbpg_egg[idx]*expc::gg[idx];

	  if (max(opts.order_hcoef,opts.order_evol) == 3)
	    continue;

	  qqb[idx]  += qqb_egg[idx] *expc::gg[idx];
	  qq[idx]   += qq_egg[idx]  *expc::gg[idx] + qq_eqbg[idx]  *expc::qbg[idx];
	  qqp[idx]  += qqp_egg[idx] *expc::gg[idx] + qqp_eqbpg[idx]*expc::qbpg[idx];
	  qqbp[idx] += qqbp_egg[idx]*expc::gg[idx] + qqbp_eqpg[idx]*expc::qpg[idx];
	  gg[idx]   += gg_eqq[idx]  *expc::qq[idx] + gg_eqqp[idx]  *expc::qqp[idx] + gg_eqqbp[idx]  *expc::qqbp[idx] + gg_eqbg[idx]*expc::qbg[idx] + gg_eqpg[idx]*expc::qpg[idx] + gg_eqbpg[idx]*expc::qbpg[idx];
	  qbg[idx]  += qbg_eqbg[idx]  *expc::qbg[idx];
	  qpg[idx]  += qpg_eqpg[idx]  *expc::qpg[idx];
	  qbpg[idx] += qbpg_eqbpg[idx]*expc::qbpg[idx];
	  qbq[idx]   = qbq_eqqb[idx]   *expc::qqb[idx] + qbq_eqg[idx]   *expc::qg[idx] + qbq_eqq[idx]    *expc::qq[idx]   + qbq_egg[idx]   *expc::gg[idx] + qbq_eqbg[idx] *expc::qbg[idx];
	  qpqbp[idx] = qpqbp_eqqb[idx] *expc::qqb[idx] + qpqbp_eqg[idx] *expc::qg[idx] + qpqbp_eqqbp[idx]*expc::qqbp[idx] + qpqbp_egg[idx] *expc::gg[idx] + qpqbp_eqpg[idx]*expc::qpg[idx];
	  qbpqp[idx] = qbpqp_eqqb[idx] *expc::qqb[idx] + qbpqp_eqg[idx] *expc::qg[idx] + qbpqp_eqqp[idx] *expc::qqp[idx]  + qbpqp_egg[idx] *expc::gg[idx] + qbpqp_eqbpg[idx]*expc::qbpg[idx];
	  qbqp[idx]  = qbqp_eqqb[idx]  *expc::qqb[idx] + qbqp_eqg[idx]  *expc::qg[idx] + qbqp_eqq[idx]   *expc::qbqp[idx] + qbqp_eqqp[idx]  *expc::qqp[idx]  + qbqp_egg[idx]  *expc::gg[idx] + qbqp_eqbg[idx] *expc::qbg[idx] + qbqp_eqbpg[idx]*expc::qbpg[idx];
	  qbqbp[idx] = qbqbp_eqqb[idx] *expc::qqb[idx] + qbqbp_eqg[idx] *expc::qg[idx] + qbqbp_eqq[idx]  *expc::qbqbp[idx]+ qbqbp_eqqbp[idx]*expc::qqbp[idx] + qbqbp_egg[idx] *expc::gg[idx] + qbqbp_eqbg[idx]*expc::qbg[idx] + qbqbp_eqpg[idx]*expc::qpg[idx];
	  qpqp[idx]  = qpqp_eqqb[idx]  *expc::qqb[idx] + qpqp_eqg[idx]  *expc::qg[idx] + qpqp_eqqp[idx]  *expc::qqp[idx]  + qpqp_eqqbp[idx] *expc::qqbp[idx] + qpqp_egg[idx]  *expc::gg[idx] + qpqp_eqpg[idx] *expc::qpg[idx] + qpqp_eqbpg[idx]*expc::qbpg[idx];
	}  
  else //rapidity dependent
    for (int sign = mesq::positive; sign <= mesq::negative; sign++)
      for (int i1 = 0; i1 < mellinint::mdim; i1++)
	for (int i2 = 0; i2 < mellinint::mdim; i2++)
	  {
	    int idx = hcoeff::index(i1,i2,sign);

	    qqb[idx]   = qqb_eqqb[idx] *expc::qqb[idx];
	    qg_1[idx]  = qg_1_eqqb[idx]*expc::qqb[idx];
	    qg_2[idx]  = qg_2_eqqb[idx]*expc::qqb[idx];
	    
	    if (max(opts.order_hcoef,opts.order_evol) == 1)
	      continue;

	    qqb[idx]    += qqb_eqg_1[idx] *expc::qg_1[idx] + qqb_eqg_2[idx]*expc::qg_2[idx];
	    qg_1[idx]   += qg_1_eqg_1[idx]*expc::qg_1[idx];
	    qg_2[idx]   += qg_2_eqg_2[idx]*expc::qg_2[idx];
	    qq_1[idx]   = qq_1_eqqb[idx]  *expc::qqb[idx] + qq_1_eqg_1[idx]*expc::qg_1[idx]  ;
	    qq_2[idx]   = qq_2_eqqb[idx]  *expc::qqb[idx] + qq_2_eqg_2[idx]*expc::qg_2[idx]  ;
	    qqp_1[idx]  = qqp_1_eqqb[idx] *expc::qqb[idx] + qqp_1_eqg_1[idx]*expc::qg_1[idx] ;
	    qqp_2[idx]  = qqp_2_eqqb[idx] *expc::qqb[idx] + qqp_2_eqg_2[idx]*expc::qg_2[idx] ;
	    qqbp_1[idx] = qqbp_1_eqqb[idx]*expc::qqb[idx] + qqbp_1_eqg_1[idx]*expc::qg_1[idx];
	    qqbp_2[idx] = qqbp_2_eqqb[idx]*expc::qqb[idx] + qqbp_2_eqg_2[idx]*expc::qg_2[idx];
	    gg[idx]     = gg_eqqb[idx]    *expc::qqb[idx] + gg_eqg_1[idx]*expc::qg_1[idx] + gg_eqg_2[idx]*expc::qg_2[idx];

	    if (max(opts.order_hcoef,opts.order_evol) == 2)
	      continue;

	    qg_1[idx]   += qg_1_eqg_2[idx]*expc::qg_2[idx] + qg_1_eqq_1[idx]*expc::qq_1[idx] + qg_1_eqqp_1[idx]*expc::qqp_1[idx] + qg_1_eqqbp_1[idx]*expc::qqbp_1[idx] + qg_1_egg[idx]*expc::gg[idx];
	    qg_2[idx]   += qg_2_eqg_1[idx]*expc::qg_1[idx] + qg_2_eqq_2[idx]*expc::qq_2[idx] + qg_2_eqqp_2[idx]*expc::qqp_2[idx] + qg_2_eqqbp_2[idx]*expc::qqbp_2[idx] + qg_2_egg[idx]*expc::gg[idx];
	    qq_1[idx]   += qq_1_eqq_1[idx]*expc::qq_1[idx];
	    qq_2[idx]   += qq_2_eqq_2[idx]*expc::qq_2[idx];
	    qqp_1[idx]  += qqp_1_eqqp_1[idx]*expc::qqp_1[idx];
	    qqp_2[idx]  += qqp_2_eqqp_2[idx]*expc::qqp_2[idx];
	    qqbp_1[idx] += qqbp_1_eqqbp_1[idx]*expc::qqbp_1[idx];
	    qqbp_2[idx] += qqbp_2_eqqbp_2[idx]*expc::qqbp_2[idx];
	    gg[idx]     += gg_egg[idx]*expc::gg[idx];
	    qbg_1[idx]  = qbg_1_eqqb[idx]  *expc::qqb[idx]+ qbg_1_eqg_1[idx]*expc::qg_1[idx] + qbg_1_eqg_2[idx]*expc::qg_2[idx] + qbg_1_eqq_2[idx]*expc::qq_2[idx] + qbg_1_egg[idx]*expc::gg[idx];
	    qbg_2[idx]  = qbg_2_eqqb[idx]  *expc::qqb[idx]+ qbg_2_eqg_1[idx]*expc::qg_1[idx] + qbg_2_eqg_2[idx]*expc::qg_2[idx] + qbg_2_eqq_1[idx]*expc::qq_1[idx] + qbg_2_egg[idx]*expc::gg[idx];
	    qpg_1[idx]  = qpg_1_eqqb[idx]  *expc::qqb[idx]+ qpg_1_eqg_1[idx]*expc::qg_1[idx] + qpg_1_eqg_2[idx]*expc::qg_2[idx] + qpg_1_eqqbp_2[idx]*expc::qqbp_2[idx] + qpg_1_egg[idx]*expc::gg[idx];
	    qpg_2[idx]  = qpg_2_eqqb[idx]  *expc::qqb[idx]+ qpg_2_eqg_1[idx]*expc::qg_1[idx] + qpg_2_eqg_2[idx]*expc::qg_2[idx] + qpg_2_eqqbp_1[idx]*expc::qqbp_1[idx] + qpg_2_egg[idx]*expc::gg[idx];
	    qbpg_1[idx] = qbpg_1_eqqb[idx] *expc::qqb[idx]+ qbpg_1_eqg_1[idx]*expc::qg_1[idx] + qbpg_1_eqg_2[idx]*expc::qg_2[idx] + qbpg_1_eqqp_2[idx]*expc::qqp_2[idx] + qbpg_1_egg[idx]*expc::gg[idx];
	    qbpg_2[idx] = qbpg_2_eqqb[idx] *expc::qqb[idx]+ qbpg_2_eqg_1[idx]*expc::qg_1[idx] + qbpg_2_eqg_2[idx]*expc::qg_2[idx] + qbpg_2_eqqp_1[idx]*expc::qqp_1[idx] + qbpg_2_egg[idx]*expc::gg[idx];

	    //NNNNLO to be implemented
	  }
}


void muf::calc(complex <double> b)
{
  //LO
  if (opts.order_hcoef == 0)
    return;

  if (opts.mellin1d) //rapidity integrated
    calc1d();
  else
    calc2d();
  
  /*
  double LQb = LQ;
  double LFb = LF;
  if (opts.mufevol && real(b) > 0)
    {
      double m = phasespace::m;
      double mub = real(pdfevol::mub);
      double muf = scales::fac;
      double Q = scales::res;
      double m2tilde   = pow(m*mub,2)/(pow(m,2) + pow(mub,2));
      double Q2tilde   = pow(Q*mub,2)/(pow(Q,2) + pow(mub,2));
      double muf2tilde = pow(muf*mub,2)/(pow(muf,2) + pow(mub,2));
      LQb = log(m2tilde/Q2tilde);
      LFb = log(m2tilde/muf2tilde);
      
      //LQb = log( pow(phasespace::m,2)/(pow(scales::res*real(pdfevol::mub),2)/(pow(scales::res,2) + pow(real(pdfevol::mub),2))));
      //LFb = log( pow(phasespace::m,2)/(pow(scales::fac*real(pdfevol::mub),2)/(pow(scales::fac,2) + pow(real(pdfevol::mub),2))));
    }
  //LQb=0.;
  //LFb=0.;
  double LQb2 = pow(LQb,2);
  double LQb3 = pow(LQb,3);
  double LQb4 = pow(LQb,3);
  double LQb5 = pow(LQb,3);

  double LFb2 = pow(LFb,2);
  double LFb3 = pow(LFb,3);
  
  double LQFb = LFb - LQb;
  */
}

